proc XCeptSetTkBindings {} {
    global tk_version

    # ... Enty widget bindings ...
    set bindEntryLeft {
	%W icursor [expr [%W index insert] - 1]
#	tk_entrySeeCaret %W
	tkEntrySeeInsert %W
    }
    set bindEntryRight {
	%W icursor [expr [%W index insert] + 1]
#	tk_entrySeeCaret %W
	tkEntrySeeInsert %W	
    }
    set bindEntryBackSpace {
	if [tk_entryHasSelection %W] {
	    %W delete sel.first sel.last
	} else {
	    tkEntryBackspace %W
	}
#	tk_entrySeeCaret %W
	tkEntrySeeInsert %W
    }
    set bindEntryDelete {
	if {[tk_entryHasSelection %W]} {
	    %W delete sel.first sel.last
	} else {
	    %W delete [%W index insert]
	}
#	tk_entrySeeCaret %W
	tkEntrySeeInsert %W
    }

    bind Entry <Left> $bindEntryLeft
    bind Entry <Control-b> $bindEntryLeft

    bind Entry <Right> $bindEntryRight
    bind Entry <Control-f> $bindEntryRight

    bind Entry <BackSpace> $bindEntryBackSpace
    bind Entry <Control-h> $bindEntryBackSpace
#    bind Entry <Control-h> {
#	tk_entryBackspace %W
#	tk_entrySeeCaret %W
#    }

    bind Entry <Delete> $bindEntryDelete
    bind Entry <Control-d> $bindEntryDelete
#    bind Entry <Control-d> {
#	%W delete [%W index insert]
#	tk_entrySeeCaret %W
#    }

    bind Entry <Control-a> {%W icursor 0; tk_entrySeeCaret %W}
    bind Entry <Home> {%W icursor 0; tk_entrySeeCaret %W}
    bind Entry <Control-e> {%W icursor end; tk_entrySeeCaret %W}
    bind Entry <End> {%W icursor end; tk_entrySeeCaret %W}
    bind Entry <Control-k> {%W delete insert end}

    bind Entry <1> {
	%W icursor @%x
	%W select clear
	%W select from @%x
	if {[lindex [%W config -state] 4] == "normal"} {focus %W}
    }
    bind Entry <2> {
	%W insert insert [tk_getSelection]
#	tk_entrySeeCaret %W
	tkEntrySeeInsert %W
    }
    bind Entry <B2-Motion> {}
    bind Entry <3> {%W scan mark %x}
    bind Entry <B3-Motion> {%W scan dragto %x}


    # ... Text widget bindings ...
    
    set bindTextLeft {
	%W mark set insert insert-1c
	%W yview -pickplace insert
    }
    set bindTextRight {
	%W mark set insert insert+1c
	%W yview -pickplace insert
    }
    set bindTextUp {
	%W mark set insert insert-1l
	%W yview -pickplace insert
    }
    set bindTextDown {
	%W mark set insert insert+1l
	%W yview -pickplace insert
    }
    set bindTextBackSpace {
	if {[tk_textHasSelection %W]} {
	    %W delete sel.first sel.last
	} else {
	    tk_textBackspace %W
	}
	%W yview -pickplace insert
    }
    set bindTextDelete {
	if {[tk_textHasSelection %W]} {
	    %W delete sel.first sel.last
	} else {
	    tk_textDelete %W
	}
	%W yview -pickplace insert
    }

    bind Text <Left> $bindTextLeft 
    bind Text <Control-b> $bindTextLeft

    bind Text <Right> $bindTextRight
    bind Text <Control-f> $bindTextRight

    bind Text <Up> $bindTextUp
    bind Text <Control-p> $bindTextUp

    bind Text <Down> $bindTextDown
    bind Text <Control-n> $bindTextDown

    bind Text <Home> {
	%W mark set insert 1.0
	%W yview -pickplace insert
    }
    bind Text <End> {
	%W mark set insert end
	%W yview -pickplace insert
    }
    bind Text <Prior> {
	%W mark set insert insert-10l
	%W yview -pickplace insert
    }
    bind Text <Next> {
	%W mark set insert insert+10l
	%W yview -pickplace insert
    }
    
    bind Text <BackSpace> $bindTextBackSpace
    bind Text <Control-h> $bindTextBackSpace
#    bind Text <Control-h> {
#	tk_textBackspace %W
#	%W yview -pickplace insert
#    }

    bind Text <Delete> $bindTextDelete
    bind Text <Control-d> $bindTextDelete
#    bind Text <Control-d> {
#	tk_textDelete %W
#	%W yview -pickplace insert
#    }

    bind Text <Control-a> {
	%W mark set insert "insert linestart"
	%W yview -pickplace insert
    }
    bind Text <Control-e> {
	%W mark set insert "insert lineend"
	%W yview -pickplace insert
    }
    bind Text <Control-k> {
	if {[%W compare insert == "insert lineend"]} {
	    tk_textDelete %W
	} else {
	    %W delete insert "insert lineend"
	}
	%W yview -pickplace insert
    }
   
   bind Text <1> {
       set tk_priv(selectMode) char
       %W tag remove sel 0.0 end
       %W mark set insert @%x,%y
       %W mark set anchor insert
       if {[lindex [%W config -state] 4] == "normal"} {
	   focus %W
       }
   }
   bind Text <2> {
       %W insert insert [tk_getSelection]
       %W yview -pickplace insert
   }
   bind Text <B2-Motion> {}
   bind Text <3> {%W scan mark %y}
   bind Text <B3-Motion> {%W scan dragto %y}
}


# ... misc procs live here ...
# ... get selection ...
proc tk_getSelection {} {
    set s ""
    catch { set s [selection get] }
    return $s
}

# ... have we got the selection? ...
proc tk_entryHasSelection w {
    return ![catch { $w index sel.first }]
}

# ... get rid of this junk, once and for all! ...
proc tk_textDelete w {
    if [$w compare insert < end] {$w delete insert}
}

# ... have we got the selection? ...
proc tk_textHasSelection w {
    return [llength [$w tag ranges sel]]
}



