#
# copied from dialog.tcl
#

proc inputBox {w title message {defmsg "Hurz!"} {echoflag 1}} {
    global textstring secretstring tk_priv

    catch {destroy $w}
    toplevel $w
    wm title $w $title

    frame $w.top -relief raised -bd 1
    frame $w.bot -relief raised -bd 1
    pack $w.top $w.bot -side top -in $w -fill both

    label $w.label -text $message
    set textstring $defmsg
    entry $w.entry -relief sunken -width 30 -textvariable textstring
    pack $w.label $w.entry -side top -in $w.top -pady 3 -anchor w -padx 5

    button $w.canbutt -relief raised -text Cancel -padx 2 \
	-command "set tk_priv(button) 0"
    button $w.okbutt -relief raised -text OK -padx 2 \
	-command "set tk_priv(button) 1"
    pack $w.okbutt $w.canbutt -side right -in $w.bot -padx 10 -pady 5

    bind $w <Return> "$w.okbutt flash; set tk_priv(button) 1"
    bind $w.entry <Return> "$w.okbutt flash; set tk_priv(button) 1"

    if {$echoflag==0} {
	set secretstring ""
	bind $w.entry <Any-KeyPress> {
	    if {"%A" != ""} {
	        %W insert insert *
		append secretstring %A
	    }
	}
	bind $w.entry <Delete> {inputBackspace %W}
	bind $w.entry <BackSpace> {inputBackspace %W}
	bind $w.entry <Control-h> {inputBackspace %W}
    }

    wm withdraw $w
    update idletasks
    set x [expr [XCeptMouse x] - [winfo reqwidth $w]/2 \
            - [winfo vrootx [winfo parent $w]]]
    set y [expr [XCeptMouse y] - [winfo reqheight $w]/2 \
            - [winfo vrooty [winfo parent $w]]]
    wm geom $w +$x+$y
    wm deiconify $w

    # Set a grab and claim the focus too.

    set oldFocus [focus]
    grab $w
    focus $w.entry

    # Wait for the user to respond, then restore the focus and
    # return the index of the selected button.

    tkwait variable tk_priv(button)
    destroy $w
    focus $oldFocus

    if {$echoflag==0} {set textstring $secretstring}

    if {$tk_priv(button)=="1"}  then {return $textstring} \
				else {return ""}
}


proc inputBackspace {w} {
   global secretstring

   set secretstring [string range $secretstring 0 \
	[expr [string length $secretstring]-2] ]
   tk_entryBackspace $w
   tk_entrySeeCaret $w
}
