# (C) 1994, Dirk Husemann, IMMD IV, Universitt Erlangen-Nrnberg

# DxJlogin --- login to the DxJ service, in case we're already logged in
#              go to DxJ page *0#
#
proc DxJlogin {{loginId -} {DxJNumber -} {userId -} {password -}} {
  global XCeptStatus XCeptHostname XCeptPortNumber

  # ... are we online yet? ...
  if { $XCeptHostname == "192.168.0.1" } {
      if {![string match CONNECTED* $XCeptStatus]} {
          XCeptConnect $XCeptHostname $XCeptPortNumber                            
          XCeptWaitDCT
      }
  } else {
      if {![string match ONLINE* $XCeptStatus]} {
	  XCeptConnect $XCeptHostname $XCeptPortNumber
	  XCeptWaitDCT
      } 
  }
  # ... look wether we got a Dx-J page number lurking around ...
  set page [string trim [XCeptGetRect 27 24 40 24]]

  # ... have we logged on yet? ...
  if {![regexp {[0-9a-z]+$} $page]} {
    # ... check validity of params ...
    # ... shamelessly copied from Thomas Eirich's xcept.pl 8=) ...

    # ... loginId must be 12 digits or none if using the guest account ...
    if {[string match - $loginId]} {
	# ... fast login procedure for guest account, nothing to 
	#     be observed here ...
	XCeptSend "\\#"
	XCeptWaitDCT

	return
    } elseif {!([regexp {^[0-9]+$} $loginId] && \
	  [expr [string length $loginId] == 12])} {
      return -1
    }

    # ... password should be at least 4 chars and at most 8 ...
    if {!([expr [string length $password] >= 4] && \
	  [expr [string length $password] <= 8])} {      
      return -2
    }
    if {[string length $password] < 8} {
      append password "\\#"
    }

    # ... userId must be 0-3 digits long ...
    if {[string match - $userId]} {
      set $userId ""
    } elseif {!([regexp {^[0-9][0-9]*$} $userId] && \
		[string length $userId] && \
	        [expr [string length $userId] <= 4])} {
      return -3
    } 
    if {[string length $userId] < 4} {
      append userId "\\#"
    }

    # ... DxJNumber must 0-12 digits long or be equal to "\\#" ...
    # not used any more -> no check
    #if {[string match - $DxJNumber]} {
    #  set $DxJNumber ""
    #} elseif {!([regexp {^[0-9]+$} $DxJNumber] && \
    #		[string length $DxJNumber] && \
    #	        [expr [string length $DxJNumber] <= 12])} {
    #  return -4
    #} 
    #if {[string length $DxJNumber] < 12} {
    #  append DxJNumber "\\#"
    #}

    # ... now, log in ...
    # ... "Anschlusskennung" --- loginId ...
    XCeptSend $loginId
    XCeptWaitDCT
    
    # ... "Datex-J-Nummer" --- DxJNumber ...
    # wird nicht mehr gebraucht
    # XCeptSend $DxJNumber
    # XCeptWaitDCT

    # ... "Mitbenutzer oder # eingeben" --- userId ...
    XCeptSend $userId
    XCeptWaitDCT

    # ... "Pers. Kennwort" --- password ...
    XCeptSend $password
    XCeptWaitDCT
 
    # Patch richterj@t-online.de Feb.99
    # ceptd (host: 192.168.0.1, port: 516) von t-online verhaelt sich 
    # anders als der, der ueber "01910" zu erreichen ist
    while 1 { 
       if { [XCeptGetRect 5 19 34 19] == "Sie benutzten T-Online zuletzt" } { break } 
       #puts "Wait DCT"
       XCeptWaitDCT
    }

  }
  # ... in any case, go to page *0# ...
  XCeptSend "\\*0\\#"
  XCeptWaitDCT
}

# EOF
