set chargePerMinute 0.06

# ... figure out the connection cost from the call duration ...
proc connectionCosts {duration} {
    global chargePerMinute

    regsub {([0-9]+):([0-9]+)} $duration {(\1 * 60 + \2)} duration
    return [expr $duration * $chargePerMinute]
}

# ... get rid of those nice commas ...
proc normalizeCosts {costs} {
    regsub {([0-9]+),([0-9]+)} $costs {\1.\2} costs

    return $costs
}

# ... save the accounting data from the Dx-J service (*90#) ...
proc DxJSaveAccountingData {{accountingFile "~/.xcept-account"}} {
    xceptPage

    # ... "Nutzungdaten" ...
    xceptPage 90

    # ... who are we? ...
    set usageDxJNumber [string trim [XCeptGetRect 13 5 24 5]]
    set usageDxJSubNumber [string trim [XCeptGetRect 26 5 30 5]]

    # ... costs page ...
    xceptEnter 1 0
    set usageDate [string trim [XCeptGetRect 33 5 40 5]]
    set usageTime [string trim [XCeptGetRect 36 6 40 6]]
    set usageDuration [string trim [XCeptGetRect 24 15 32 15]]

    set usageCostsPages [normalizeCosts [string trim \
	    [XCeptGetRect 31 17 38 17]]]
    set usageCostsDuration [normalizeCosts [string trim \
	    [XCeptGetRect 31 18 38 18]]]
    set usageCostsRegionals [normalizeCosts [string trim \
	    [XCeptGetRect 31 20 38 20]]]
    set usageCostsMessages [normalizeCosts [string trim \
	    [XCeptGetRect 31 20 38 20]]]

    set totalCosts [format "%6.2f" [expr $usageCostsPages + \
	    $usageCostsDuration + $usageCostsRegionals + \
	    $usageCostsMessages + [connectionCosts $usageDuration]]]

    set accLine "$usageDxJNumber-$usageDxJSubNumber $usageTime@$usageDate "
    append accLine "$usageDuration DM $totalCosts ("
    append accLine "P: $usageCostsPages "
    append accLine "T: $usageCostsDuration "
    append accLine "R: $usageCostsRegionals "
    append accLine "M: $usageCostsMessages"
    append accLine ")"

    set account [open $accountingFile a+ 0600]
    puts $account $accLine
    flush $account
    close $account
}
