# customButtons --- implements custom buttons
global images
global bitmapsPerRow
global currentBitmapsPerRow

set images "$XCeptSysDir/images"
set bitmapsPerRow 8
set currentBitmaps 0

proc lookupBitmap {bitmap {path ""}} {
    global images

    if {$path == ""} {
	set path $images
    }

    if {[file exists "$path/$bitmap.xbm"]} {
	set bitmap "$path/$bitmap.xbm"
    } elseif {[file exists "$path/DEFAULT.xbm"]} {
	set bitmap "$path/DEFAULT.xbm"
    } else {
	set bitmap ""
    }
}

proc newButton {button bitmap command {description ""} {userPath ""}} {
    global images
    global tk_version
    global bitmapsPerRow
    global currentBitmaps

    # ... only do this once! ...
    if {![winfo exists .infoframe]} {
	# ... infoframe will display some descriptive messages ...
	frame .infoframe -bd 2 -relief groove
	label .infoicon -bitmap questhead -width 10
	label .infotext -text ""
	pack .infoicon -in .infoframe -side left -padx 3
	pack .infotext -in .infoframe -side left -fill x -padx 3
	pack .infoframe -in .mainframe -side top -fill x -pady 5 -padx 3
    }
    
#    catch { 
	if {[string index $bitmap 0] == ":"} {
	    set bitmap [string trimleft $bitmap ":"]
	    set textualBitmap 1
	} else {
	    if {$userPath != ""} {
		set bitmap [lookupBitmap $bitmap $userPath]
	    } else {
		set bitmap [lookupBitmap $bitmap]
	    }

	    if {$bitmap == ""} {
		set bitmap "Ooops"
		set textualBitmap 1
	    } else {
		set textualBitmap 0
	    }
	}

        set cframerow [expr int($currentBitmaps/$bitmapsPerRow)]
	incr currentBitmaps
        if {![winfo exists .customframe$cframerow]} {
	    frame .customframe$cframerow
	    pack .customframe$cframerow -in .mainframe -side top -fill x \
		    -padx 3
	}

        if {$textualBitmap} {
	    button $button -text "$bitmap" -command $command
	} else {
	    button $button -bitmap "@$bitmap" -command $command
	}
	pack $button -in .customframe$cframerow -side left -fill y

	if {$description != ""} {
	    bind $button <Enter> "tkButtonEnter %W; \
		    .infotext config -text {$description}"
	    bind $button <Leave> "tkButtonLeave %W; \
		    .infotext config -text {}"
	}
#    }
}
